package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.ConexionDescuentoDAO;
import com.rjconsultores.ventaboletos.entidad.ConexionDescuento;

@Repository("conexionDescuentoDAO")
public class ConexionDescuentoHibernateDAO extends GenericHibernateDAO<ConexionDescuento, Long>
implements ConexionDescuentoDAO {

	@Autowired
	public ConexionDescuentoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}
	
	@Override
	@SuppressWarnings("unchecked")
	public List<ConexionDescuento> bucarPorConexion(Long conexionId) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("conexion.conexionId", conexionId));
		c.add(Restrictions.eq(ACTIVO, true));
		return c.list();
	}
	
	@Override
	@SuppressWarnings("unchecked")
	public List<ConexionDescuento> bucarPorConexionInativos(Long conexionId) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("conexion.conexionId", conexionId));
		c.add(Restrictions.eq(ACTIVO, false));
		return c.list();
	}

}
